Name:           perl-DBIx-Class
Version:        0.08108
Release:        1%{?dist}
Summary:        Extensible and flexible object <-> relational mapper
License:        GPL+ or Artistic
Group:          Development/Libraries
URL:            http://search.cpan.org/dist/DBIx-Class/
Source0:        http://search.cpan.org/CPAN/authors/id/R/RI/RIBASUSHI/DBIx-Class-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

# core
BuildRequires:  perl >= 1:5.6.1
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.42
BuildRequires:  perl(Scalar::Util)
BuildRequires:  perl(Storable)
BuildRequires:  perl(Test::Builder) >= 0.33
BuildRequires:  perl(Test::Deep)

# Required by inc/Module/AutoInstall
BuildRequires:  perl(CPAN)

## Dependencies
BuildRequires:  perl(Carp::Clan) >= 6
BuildRequires:  perl(Class::Accessor::Grouped) >= 0.08003
BuildRequires:  perl(Class::C3) >= 0.2
BuildRequires:  perl(Class::C3::Componentised) >= 1.0005
# for CDBI-compat bits...
BuildRequires:  perl(Class::Data::Inheritable)
BuildRequires:  perl(Class::Inspector) >= 1.24
BuildRequires:  perl(Class::Trigger)
BuildRequires:  perl(Data::Page) >= 2
BuildRequires:  perl(DBD::SQLite) >= 1.25
BuildRequires:  perl(DBI) >= 1.605
BuildRequires:  perl(DBIx::ContextualFetch)
BuildRequires:  perl(JSON::Any) >= 1.18
BuildRequires:  perl(List::Util) >= 1.19
BuildRequires:  perl(Module::Find) >= 0.06
BuildRequires:  perl(Scope::Guard) >= 0.03
BuildRequires:  perl(SQL::Abstract) >= 1.56
BuildRequires:  perl(SQL::Abstract::Limit) >= 0.13
BuildRequires:  perl(Test::Exception)
# optional tests
BuildRequires:  perl(DateTime::Format::MySQL)
BuildRequires:  perl(Text::CSV_XS)
BuildRequires:  perl(Test::Memory::Cycle)
BuildRequires:  perl(Test::Pod)
BuildRequires:  perl(Test::Pod::Coverage)
BuildRequires:  perl(SQL::Translator)
BuildRequires:  perl(DateTime)
BuildRequires:  perl(DateTime::Format::Oracle)
BuildRequires:  perl(DBIx::ContextualFetch)
# optional tests as of 0.08102
BuildRequires:  perl(Clone)
BuildRequires:  perl(Time::Piece)
BuildRequires:  perl(Time::Piece::MySQL)
# .. the following are also needed as a requires for replicated dbd support
BuildRequires:  perl(MooseX::AttributeHelpers) >= 0.12
BuildRequires:  perl(Class::MOP) >= 0.63
BuildRequires:  perl(Moose) >= 0.54
BuildRequires:  perl(Moose::Util::TypeConstraints) >= 0.54

BuildRequires:  perl(Test::More) >= 0.82
BuildRequires:  perl(MRO::Compat) >= 0.09
BuildRequires:  perl(Test::Warn) >= 0.11
BuildRequires:  perl(Sub::Name) >= 0.04
BuildRequires:  perl(Path::Class) >= 0.16

# these are hidden from PAUSE, yet picked up by us
Provides:       perl(DBIx::Class::ClassResolver::PassThrough) = 0
Provides:       perl(DBIx::Class::CDBICompat::Relationship) = 0
Provides:       perl(DBIx::Class::Storage::DBI::Replicated::Types) = 0

# not picked up...
Requires:       perl(Class::Accessor::Grouped) >= 0.08003
Requires:       perl(Class::C3::Componentised) >= 1.0005
Requires:       perl(SQL::Abstract) >= 1.56

### auto-added reqs!
Requires:  perl(Carp::Clan) >= 6
Requires:  perl(Class::Inspector) >= 1.24
Requires:  perl(DBD::SQLite) >= 1.25
Requires:  perl(DBI) >= 1.605
Requires:  perl(Data::Page) >= 2
Requires:  perl(JSON::Any) >= 1.18
Requires:  perl(List::Util)
Requires:  perl(MRO::Compat) >= 0.09
Requires:  perl(Module::Find) >= 0.06
Requires:  perl(Path::Class) >= 0.16
Requires:  perl(SQL::Abstract::Limit) >= 0.13
Requires:  perl(Scalar::Util)
Requires:  perl(Scope::Guard) >= 0.03
Requires:  perl(Storable)
Requires:  perl(Sub::Name) >= 0.04

# don't "provide" rpm-metadata for things we shouldn't
%global _use_internal_dependency_generator 0
%global __deploop() while read FILE; do /usr/lib/rpm/rpmdeps -%{1} ${FILE}; done | /bin/sort -u
%global __find_provides /bin/sh -c "%{__grep} -v '%_docdir' | %{__grep} -v '%{perl_vendorarch}/.*\\.so$' | %{__deploop P}"
%global __find_requires /bin/sh -c "%{__grep} -v '%_docdir' | %{__deploop R} | %{__sed} -e '/perl(DBD::Pg)/d; /perl(DBD::Oracle)/d'"


%description
This is an SQL to OO mapper with an object API inspired by Class::DBI
(and a compatibility layer as a springboard for porting) and a
resultset API that allows abstract encapsulation of database
operations. It aims to make representing queries in your code as perl-
ish as possible while still providing access to as many of the
capabilities of the database as possible, including retrieving related
records from multiple tables in a single query, JOIN, LEFT JOIN, COUNT,
DISTINCT, GROUP BY and HAVING support.

%prep
%setup -q -n DBIx-Class-%{version}

find t/ -type f -exec perl -pi -e 's|\r||; s|^#!perl|#!/usr/bin/perl|' {} +
find .  -type f -exec chmod -c -x {} +
find t/ -type f -name '*.orig' -exec rm -v {} +

# utf8 issues
for i in `find . -type f` ; do
    iconv -f iso8859-1 -t UTF-8 $i > foo
    mv foo $i
done

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}

make pure_install PERL_INSTALL_ROOT=%{buildroot}

find %{buildroot} -type f -name .packlist -exec rm -f {} +
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null \;

%{_fixperms} %{buildroot}/*

%check
# note this test suite is noisy!
export DBICTEST_THREAD_STRESS=1
export DBICTEST_FORK_STRESS=1
export DBICTEST_STORAGE_STRESS=1
export DATA_DUMPER_TEST=1
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README examples/ t/
%{perl_vendorlib}/*
%{_bindir}/*
%{_mandir}/man[13]/*


%changelog
* Fri Jul 31 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.08108-1
- auto-update to 0.08108 (by cpan-spec-update 0.01)

* Thu Jul 30 2009 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.08107-3
- Add BR: perl(CPAN) to fix rebuild-breakdown.

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.08107-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Mon Jun 15 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.08107-1
- auto-update to 0.08107 (by cpan-spec-update 0.01)
- altered br on perl(DBD::SQLite) (1.13 => 1.25)
- altered br on perl(SQL::Abstract) (1.55 => 1.56)
- added a new req on perl(Carp::Clan) (version 6)
- altered req on perl(Class::Accessor::Grouped) (0.05002 => 0.08003)
- altered req on perl(Class::C3::Componentised) (0 => 1.0005)
- added a new req on perl(Class::Inspector) (version 1.24)
- added a new req on perl(DBD::SQLite) (version 1.25)
- added a new req on perl(DBI) (version 1.605)
- added a new req on perl(Data::Page) (version 2)
- added a new req on perl(JSON::Any) (version 1.18)
- added a new req on perl(List::Util) (version 0)
- added a new req on perl(MRO::Compat) (version 0.09)
- added a new req on perl(Module::Find) (version 0.06)
- added a new req on perl(Path::Class) (version 0.16)
- altered req on perl(SQL::Abstract) (1.2 => 1.56)
- added a new req on perl(SQL::Abstract::Limit) (version 0.13)
- added a new req on perl(Scalar::Util) (version 0)
- added a new req on perl(Scope::Guard) (version 0.03)
- added a new req on perl(Storable) (version 0)
- added a new req on perl(Sub::Name) (version 0.04)
- ** manual updates follow
- force a provides on perl(DBIx::Class::Storage::DBI::Replicated::Types)
- rejigger filtering to a cleaner variant
- drop remaining patch artifacts

* Fri May 29 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.08103-1
- auto-update to 0.08103 (by cpan-spec-update 0.01)
- altered br on perl(Class::Inspector) (0 => 1.24)
- altered br on perl(Carp::Clan) (0 => 6)
- altered br on perl(JSON::Any) (1.17 => 1.18)
- altered br on perl(Module::Find) (0 => 0.06)
- altered br on perl(DBI) (1.4 => 1.605)
- altered br on perl(SQL::Abstract) (1.51 => 1.55)
- added a new br on perl(Test::More) (version 0.82)
- altered br on perl(Path::Class) (0 => 0.16)

* Sun May 24 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.08102-3
- we should also provide perl(DBIx::Class::CDBICompat::Relationship) (and do
  now so provide)

* Sun May 24 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.08102-2
- additional BR's for optional tests

* Sun May 24 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.08102-1
- drop verbose.patch: largely supersceded
- auto-update to 0.08102 (by cpan-spec-update 0.01)
- added a new br on perl(MRO::Compat) (version 0.09)
- added a new br on perl(Test::Warn) (version 0.11)
- altered br on perl(SQL::Abstract) (1.24 => 1.51)
- added a new br on perl(Sub::Name) (version 0.04)
- altered br on perl(Test::Builder) (0.32 => 0.33)
- altered br on perl(Class::C3::Componentised) (0 => 1.0005)
- altered br on perl(Class::Accessor::Grouped) (0.08002 => 0.08003)
- added a new br on perl(Path::Class) (version 0)

* Sun Mar 22 2009 Robert Scheck <robert@fedoraproject.org> 0.08012-3
- Added missing build requirement perl(Test::Deep) for make tests
- Re-diffed make tests patch for more verbosity when skipping tests

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.08012-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Feb 22 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.08012-1
- update to 0.08012

* Thu Oct 16 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-9
- stop filtering perl(DBD::Multi)

* Sun Oct 05 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-8
- filter all prov/req from anything under _docdir
- note we still filter perl(DBD::Multi), at least until review bug bz#465690
  is completed...
- ...and perl(DBD::Pg) will always be filtered

* Wed Oct 01 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-7
- fix patch fuzz

* Mon Jun 02 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-6
- bump

* Wed Apr 09 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-5
- pod coverage testing NOT enabled; test currently "fails"
- make tests skip a little more verbosely...
- add a br of Class::Data::Inheritable for the CDBI-compat testing

* Tue Apr 01 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-4
- drop unneeded patch1
- set explicit provides version to 0 :)

* Wed Mar 19 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-3
- add perl(Test::Exception) as a br
- revert patches to skip on DBD::SQLite < 1.13

* Tue Mar 18 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-2
- BR JSON -> JSON::Any
- rework sqlite/tests patch to skip on DBD::SQLite < 1.15...  1.14 is in
  rawhide/f9, and frankly, doesn't quite pass muster *sigh*

* Sun Mar 09 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08010-1
- update to 0.08010

* Wed Jan 16 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08008-3
- add additional BR's for optional tests

* Fri Jan 11 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.08008-2
- patch to work around certain tests as DBD::SQLite isn't going to 1.13
  anytime soon (see RH#245699)

* Tue Dec 04 2007 Chris Weyl <cweyl@alumni.drew.edu> 0.08008-1
- update to 0.08008
- correct provides filtering...

* Tue Sep 18 2007 Chris Weyl <cweyl@alumni.drew.edu> 0.08007-1
- Specfile autogenerated by cpanspec 1.71.
